"use client"
import { usePathname } from "next/navigation"
import { useRef } from "react"

import { createDestinationDataStore } from "@/stores/destination-data"

import { DestinationDataContext } from "@/contexts/DestinationData"

import DestinationDataProviderContent from "./Content"

import type { DestinationDataStore } from "@/types/contexts/destination-data"
import type { DestinationDataProviderProps } from "@/types/providers/destination-data"

export default function DestinationDataProvider({
  allCities = [],
  allHotels,
  sortItems,
  children,
}: DestinationDataProviderProps) {
  const storeRef = useRef<DestinationDataStore>(undefined)
  const pathname = usePathname()

  if (!storeRef.current) {
    storeRef.current = createDestinationDataStore({
      allCities,
      allHotels,
      pathname,
      sortItems,
    })
  }

  return (
    <DestinationDataContext.Provider value={storeRef.current}>
      <DestinationDataProviderContent>
        {children}
      </DestinationDataProviderContent>
    </DestinationDataContext.Provider>
  )
}
